﻿Imports System.Runtime.InteropServices
Imports System.Security.Permissions

Public Class FormPopup
#Region " Native Methods "
    Public Const WS_EX_CONTROLPARENT = &H10000
    Public Const WS_EX_TOPMOST = &H8
    Public Const WS_EX_TOOLWINDOW = &H80

    Public Const WS_POPUP = &H80000000
    Public Const WS_VISIBLE = &H10000000
    Public Const WS_CLIPSIBLINGS = &H4000000
    Public Const WS_CLIPCHILDREN = &H2000000

    Public Const CS_DROPSHADOW = &H20000
    Public Const CS_SAVEBITS = &H800

    Public Const WM_NCACTIVATE = &H86

    <DllImport("user32.dll", CharSet:=CharSet.Auto)> _
    Public Shared Function SendMessage(ByVal hWnd As HandleRef, ByVal msg As Integer, ByVal wParam As IntPtr, ByVal lParam As IntPtr) As IntPtr
    End Function

    <DllImport("user32.dll", CharSet:=CharSet.Auto)> _
    Public Shared Function GetForegroundWindow() As IntPtr
    End Function
#End Region

    Private ActiveWindowHandle As HandleRef

    Public Overloads Sub Show()
        If ActiveForm IsNot Nothing Then
            ActiveWindowHandle = New HandleRef(ActiveForm, ActiveForm.Handle)
        Else
            ActiveWindowHandle = New HandleRef(Nothing, GetForegroundWindow)
        End If
        MyBase.Show() 
    End Sub

    Public Overloads Sub Show(ByVal Location As Point)
        Me.Location = Location
        Me.Show()
    End Sub

    Protected Overrides Sub CreateHandle()
        MyBase.CreateHandle()
        Me.KeyPreview = True
    End Sub

    Protected Overrides ReadOnly Property CreateParams() As CreateParams
        Get
            Dim cParams As CreateParams = MyBase.CreateParams

            cParams.X = Location.X
            cParams.Y = Location.Y

            cParams.ClassStyle = CS_DROPSHADOW Or CS_SAVEBITS
            cParams.Style = WS_POPUP Or WS_VISIBLE Or WS_CLIPSIBLINGS Or WS_CLIPCHILDREN
            cParams.ExStyle = WS_EX_CONTROLPARENT Or WS_EX_TOOLWINDOW Or WS_EX_TOPMOST

            Return cParams
        End Get
    End Property

    Protected Overrides Sub WndProc(ByRef m As Message)
        If (m.Msg = &H86) AndAlso (m.WParam <> IntPtr.Zero) AndAlso ActiveWindowHandle <> IntPtr.Zero Then
            SendMessage(ActiveWindowHandle, WM_NCACTIVATE, CType(1, IntPtr), IntPtr.Zero)
            Me.DefWndProc(m)
        Else
            MyBase.WndProc(m)
        End If
    End Sub

    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        MyBase.OnPaint(e)
        Using p As Pen = New Pen(SystemColors.ButtonShadow)
            e.Graphics.DrawRectangle(p, 0, 0, Me.Width - 1, Me.Height - 1)
        End Using
    End Sub

    Protected Overrides Sub OnKeyDown(ByVal e As System.Windows.Forms.KeyEventArgs)
        MyBase.OnKeyDown(e)
        If (e.KeyData = Keys.Escape OrElse e.KeyData = Keys.Enter) AndAlso Me.Created Then Me.Close()
    End Sub

    Protected Overrides Sub OnDeactivate(ByVal e As System.EventArgs)
        MyBase.OnDeactivate(e)
        If Me.Created Then Me.Close()
    End Sub

    Private Sub Form2_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        DataGridView1.RowCount = 100000
    End Sub

    Private Sub DataGridView1_CellMouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellMouseEventArgs) Handles DataGridView1.CellMouseDoubleClick
        If Me.Created Then Me.Close()
    End Sub

    Private Sub DataGridView1_CellValueNeeded(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellValueEventArgs) Handles DataGridView1.CellValueNeeded
        If (e.RowIndex Mod 2) = 0 Then
            DataGridView1.Rows(e.RowIndex).Cells(e.ColumnIndex).Style.BackColor = Color.WhiteSmoke
        Else
            DataGridView1.Rows(e.RowIndex).Cells(e.ColumnIndex).Style.BackColor = Color.White
        End If
        If e.ColumnIndex <= 1 Then e.Value = (e.RowIndex + 1).ToString & ": " & (e.ColumnIndex + 1).ToString
    End Sub
End Class